/******************************************************************************/
/*                                                                            */
/*  <<< Copyright >>>                                                         */
/*                                                                            */
/*  The "xmemo" software is copyright 1999 by Takao Abe.                      */
/*  All rights reserved.                                                      */
/*                                                                            */
/*  The "xmemo" software refers to the source code, the binary code,          */
/*  the documents, and all derivatives based on this software under           */
/*  the copyright law, that is a software containing a program or a           */
/*  portion of a program, regardless of modifications and/or translations.    */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  <<< Licence and redistribution >>>                                        */
/*                                                                            */
/*  The source code and the binary code are free software.                    */
/*  The use and redistribution of source code and binary code are permitted   */
/*  provided that the following conditions are met:                           */
/*  You may use the software for private use and commercial use,              */
/*  and may modify your copy or copies of the software or any portion of it.  */
/*                                                                            */
/*  THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESSED OR IMPLIED            */
/*  WARRANTIES OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED        */
/*  WARRANTIES OF MERCHANTABLILITY AND FITNESS FOR A PARTICULAR PURPOSE.      */
/*  IN NO EVENT SHALL THE AUTHOR TAKAO ABE BE LIABLE FOR ANY DIRECT,          */
/*  INDIRECT, GENERAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES           */
/*  ( INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR       */
/*  SERVICES; LOSS OF USE, DATA OR PROFITS; OR BUSINESS INTERRUPTION )        */
/*  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,       */
/*  STRICT LIABILITY, OR TORT ( INCLUDING NEGLIGENCE OR OTHERWISE )           */
/*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED       */
/*  OF THE POSSIBILITY OF SUCH DAMAGE.                                        */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with or without     */
/*  modification, the whole program or a portion of it, are permitted         */
/*  provided that one retains the entire copyright notice properly, and       */
/*  displays or retains this license in the documentation and/or other        */
/*  materials provided with the distribution.                                 */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with modification,  */
/*  the whole program or a portion of it, are permitted provided that one     */
/*  declares that it is modified software and not original, and displays or   */
/*  describes any modifications in the documentation and/or other materials   */
/*  provided with the distribution.                                           */
/*                                                                            */
/*  This software and the name of the author must not be used to endorse or   */
/*  promote products derived from this software without prior written         */
/*  permission.                                                               */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  EMail   abetakao@bea.hi-ho.ne.jp                                          */
/*          HCA00763@nifty.ne.jp                                              */
/*                                                                            */
/*  URL     http://www.bea.hi-ho.ne.jp/abetakao/                              */
/*                                                                            */
/******************************************************************************/


#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>


#include	<X11/Intrinsic.h>
#include	<X11/StringDefs.h>
#include	<X11/Shell.h>

#include	<X11/Xaw/AsciiText.h>
#include	<X11/Xaw/Box.h>
#include	<X11/Xaw/Command.h>
#include	<X11/Xaw/Form.h>
#include	<X11/Xaw/Label.h>


#include	"xmemo.h"
#include	"xmemodata.h"
#include	"xmemofunc.h"


/******************************************************************************/
/*  Local variables                                                           */
/******************************************************************************/


static	Widget	wDlgOptionPreference ;
static	Widget	wDlgOptionPreferenceForm ;
static	Widget	wDlgOptionPreferenceEdit ;
static	Widget	wDlgOptionPreferenceLbl [ 6 ] ;
static	Widget	wDlgOptionPreferenceTxtSizeW ;
static	Widget	wDlgOptionPreferenceTxtSizeH ;
static	Widget	wDlgOptionPreferenceTxtBackColor [ 3 ] ;
static	Widget	wDlgOptionPreferenceTxtBorderW ;
static	Widget	wDlgOptionPreferenceTxtBorderColor [ 3 ] ;
static	Widget	wDlgOptionPreferenceTxtFont ;
static	Widget	wDlgOptionPreferenceTxtFontColor [ 3 ] ;
static	Widget	wDlgOptionPreferenceCmdFont ;
static	Widget	wDlgOptionPreferenceCmdClose ;
static	Widget	wDlgOptionPreferenceCmdCancel ;


static	zMemoType	*pMemoAttribute ;


/******************************************************************************/
/*  OptionPreferenceFont_Click                                                */
/******************************************************************************/

static void OptionPreferenceFont_Click ( Widget w, caddr_t pClientData, caddr_t pCallData )
{

int 	n ;
Arg 	xArg [ 10 ] ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "OptionPreferenceFont_Click", NULL ) ;

	xmemo_PopupDialog_Font ( ) ;

}

static XtCallbackRec pOptionPreferenceFont_CallbackRec [ ] =
{
	{ (XtCallbackProc) OptionPreferenceFont_Click, NULL },
	{ NULL, NULL }
} ;

/******************************************************************************/
/*  OptionPreferenceClose_Click                                               */
/******************************************************************************/

static void OptionPreferenceClose_Click ( Widget w, caddr_t pClientData, caddr_t pCallData )
{

int 	i, n ;
Arg 	xArg [ 10 ] ;
char	*pSizeW, *pSizeH ;
char	*pBackColor [ 3 ] ;
char	*pBorderW ;
char	*pBorderColor [ 3 ] ;
char	*pFontName ;
char	*pFontColor [ 3 ] ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "OptionPreferenceClose_Click", NULL ) ;

	/* Input */

	n = 0 ;
	XtSetArg ( xArg[n], XtNstring, &pSizeW ) ; n ++ ;
	XtGetValues ( wDlgOptionPreferenceTxtSizeW, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNstring, &pSizeH ) ; n ++ ;
	XtGetValues ( wDlgOptionPreferenceTxtSizeH, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNstring, &pBorderW ) ; n ++ ;
	XtGetValues ( wDlgOptionPreferenceTxtBorderW, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNstring, &pFontName ) ; n ++ ;
	XtGetValues ( wDlgOptionPreferenceTxtFont, xArg, n ) ;

	for ( i = 0 ; i < 3 ; i ++ ) {

		n = 0 ;
		XtSetArg ( xArg[n], XtNstring, &pBackColor[i] ) ; n ++ ;
		XtGetValues ( wDlgOptionPreferenceTxtBackColor[i], xArg, n ) ;

		n = 0 ;
		XtSetArg ( xArg[n], XtNstring, &pBorderColor[i] ) ; n ++ ;
		XtGetValues ( wDlgOptionPreferenceTxtBorderColor[i], xArg, n ) ;

		n = 0 ;
		XtSetArg ( xArg[n], XtNstring, &pFontColor[i] ) ; n ++ ;
		XtGetValues ( wDlgOptionPreferenceTxtFontColor[i], xArg, n ) ;

	}

	/* Check */

	if ( pSizeW == NULL
	  || pSizeH == NULL
	  || pBorderW == NULL
	  || pBorderColor[0] == NULL || pBorderColor[1] == NULL || pBorderColor[2] == NULL 
	  || pBackColor[0]   == NULL || pBackColor[1]   == NULL || pBackColor[2]   == NULL 
	  || pFontColor[0]   == NULL || pFontColor[1]   == NULL || pFontColor[2]   == NULL ) {
		XBell ( XtDisplay(wTop), 100 ) ;
		return ;
	}

	if ( ! xmemo_CheckNumericRange ( pSizeW  , MIN_DEFAULT_MEMO_WIDTH  , MAX_DEFAULT_MEMO_WIDTH   )
	  || ! xmemo_CheckNumericRange ( pSizeH  , MIN_DEFAULT_MEMO_HEIGHT , MAX_DEFAULT_MEMO_HEIGHT  )
	  || ! xmemo_CheckNumericRange ( pBorderW, MIN_DEFAULT_BORDER_WIDTH, MAX_DEFAULT_BORDER_WIDTH ) ) {
		XBell ( XtDisplay(wTop), 100 ) ;
		return ;
	}

	for ( i = 0 ; i < 3 ; i ++ ) {
		if ( ! xmemo_CheckNumericRange ( pBorderColor[i], 0, 65535 )
		  || ! xmemo_CheckNumericRange ( pBackColor[i]  , 0, 65535 )
		  || ! xmemo_CheckNumericRange ( pFontColor[i]  , 0, 65535 ) ) {
			XBell ( XtDisplay(wTop), 100 ) ;
			return ;
		}
	}

	/* Close dialog */

	xmemo_PopdownDialog_OptionPreference ( ) ;

	/* Save */

	if ( pMemoAttribute != NULL ) {

		pMemoAttribute->w = atoi ( pSizeW ) ;
		pMemoAttribute->h = atoi ( pSizeH ) ;
		pMemoAttribute->iBorderWidth = atoi ( pBorderW ) ;

		if ( pMemoAttribute->pFontName != NULL ) {
			XtFree ( (void*) ( pMemoAttribute->pFontName ) ) ;
			pMemoAttribute->pFontName = NULL ;
		}
		if ( pFontName != NULL ) {
			if ( strlen ( pFontName ) > 0 ) {
				pMemoAttribute->pFontName = XtMalloc ( strlen ( pFontName ) + 1 ) ;
				if ( pMemoAttribute->pFontName == NULL ) {
					xmemo_ErrorLog ( "OptionPreferenceClose_Click", "XtMalloc", NULL ) ;
				} else {
					strcpy ( pMemoAttribute->pFontName, pFontName ) ;
				}
			}
		}

		for ( i = 0 ; i < 3 ; i ++ ) {

			pMemoAttribute->iBorderColor[i] = atoi ( pBorderColor[i] ) ;
			pMemoAttribute->iBackColor[i]   = atoi ( pBackColor[i] ) ;
			pMemoAttribute->iFontColor[i]   = atoi ( pFontColor[i] ) ;

		}

		if ( pMemoActive->pChain != NULL ) {
			xmemo_SetMemoWidgetAttribute ( pMemoAttribute ) ;
		}

	} else {

		iDefaultMemoWidth = atoi ( pSizeW ) ;
		iDefaultMemoHeight = atoi ( pSizeH ) ;
		iDefaultMemoBorderWidth = atoi ( pBorderW ) ;

		if ( pFontName != NULL ) {
			strncpy ( sDefaultMemoFontName, pFontName, MAXLEN_FONTNAME ) ;
			sDefaultMemoFontName[MAXLEN_FONTNAME-1] = 0 ;
		}

		for ( i = 0 ; i < 3 ; i ++ ) {

			iDefaultMemoBorderColor[i] = atoi ( pBorderColor[i] ) ;
			iDefaultMemoBackColor[i]   = atoi ( pBackColor[i] ) ;
			iDefaultMemoFontColor[i]   = atoi ( pFontColor[i] ) ;

		}

		xmemo_SaveOptionPreference ( ) ;

	}

}

static XtCallbackRec pOptionPreferenceClose_CallbackRec [ ] =
{
	{ (XtCallbackProc) OptionPreferenceClose_Click, NULL },
	{ NULL, NULL }
} ;

/******************************************************************************/
/*  OptionPreferenceCancel_Click                                              */
/******************************************************************************/

static void OptionPreferenceCancel_Click ( Widget w, caddr_t pClientData, caddr_t pCallData )
{

int 	n ;
Arg 	xArg [ 10 ] ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "OptionPreferenceCancel_Click", NULL ) ;

	xmemo_PopdownDialog_OptionPreference ( ) ;

}

static XtCallbackRec pOptionPreferenceCancel_CallbackRec [ ] =
{
	{ (XtCallbackProc) OptionPreferenceCancel_Click, NULL },
	{ NULL, NULL }
} ;

/******************************************************************************/
/*  xmemo_InitDialog_OptionPreference                                         */
/******************************************************************************/

int xmemo_InitDialog_OptionPreference ( )
{

int 	n ;
Arg 	xArg [ 16 ] ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "xmemo_InitDialog_OptionPreference", NULL ) ;

	/* Dialog shell */

	n = 0 ;
	XtSetArg ( xArg[n], XtNtitle , "xmemo - Option [ Preference ]" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNwidth , 400 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNheight, 200 ) ; n ++ ;
	wDlgOptionPreference = XtCreatePopupShell ( "DlgOptPreference", transientShellWidgetClass, wTop, xArg, n ) ;
	                                  
	/* Main form */

	wDlgOptionPreferenceForm = XtCreateManagedWidget ( "Form", formWidgetClass, wDlgOptionPreference, xArg, 0 ) ;

	/* Edit area */

	n = 0 ;
	XtSetArg ( xArg[n], XtNtop   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom, XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft  , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright , XtChainRight  ) ; n ++ ;
	wDlgOptionPreferenceEdit = XtCreateManagedWidget ( "Body", formWidgetClass, wDlgOptionPreferenceForm, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth   , 100 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNlabel   , "Size ( W x H )" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0 ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNtop   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft  , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright , XtChainLeft   ) ; n ++ ;
	wDlgOptionPreferenceLbl[0] = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , NULL ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceLbl[0] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtSizeW = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , NULL ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceTxtSizeW ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtSizeH = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth   , 100 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNlabel   , "Back color" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0 ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNtop   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft  , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert, wDlgOptionPreferenceLbl[0] ) ; n ++ ;
	wDlgOptionPreferenceLbl[1] = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[0] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceLbl[1] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtBackColor[0] = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[0] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceTxtBackColor[0] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtBackColor[1] = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[0] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceTxtBackColor[1] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtBackColor[2] = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth   , 100 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNlabel   , "Border width" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0 ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNtop   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft  , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert, wDlgOptionPreferenceLbl[1] ) ; n ++ ;
	wDlgOptionPreferenceLbl[2] = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[1] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceLbl[2] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtBorderW = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth   , 100 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNlabel   , "Border color" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0 ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNtop   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft  , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert, wDlgOptionPreferenceLbl[2] ) ; n ++ ;
	wDlgOptionPreferenceLbl[3] = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[2] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceLbl[3] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtBorderColor[0] = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[2] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceTxtBorderColor[0] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtBorderColor[1] = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[2] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceTxtBorderColor[1] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtBorderColor[2] = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth   , 100 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNlabel   , "Font name" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0 ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNtop   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft  , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert, wDlgOptionPreferenceLbl[3] ) ; n ++ ;
	wDlgOptionPreferenceLbl[4] = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 200 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[3] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceLbl[4] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtFont = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNlabel    , "Font" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[3]  ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceTxtFont ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNcallback , pOptionPreferenceFont_CallbackRec ) ; n ++ ;
	wDlgOptionPreferenceCmdFont = XtCreateManagedWidget ( "CmdButton", commandWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth   , 100 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNlabel   , "Font color" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNjustify , XtJustifyLeft ) ; n ++ ;
	XtSetArg ( xArg[n], XtNborderWidth, 0 ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNtop   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft  , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert, wDlgOptionPreferenceLbl[4] ) ; n ++ ;
	wDlgOptionPreferenceLbl[5] = XtCreateManagedWidget ( "Label", labelWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[4] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceLbl[1] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtFontColor[0] = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[4] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceTxtFontColor[0] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtFontColor[1] = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNwidth    , 60 ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainTop    ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceLbl[4] ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceTxtFontColor[1] ) ; n ++ ;	
	XtSetArg ( xArg[n], XtNeditType , XawtextEdit   ) ; n ++ ;	
	wDlgOptionPreferenceTxtFontColor[2] = XtCreateManagedWidget ( "Text", asciiTextWidgetClass, wDlgOptionPreferenceEdit, xArg, n ) ;

	/* Command button ( Bottom ) */

	n = 0 ;
	XtSetArg ( xArg[n], XtNlabel    , "OK" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainBottom ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainBottom ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceEdit ) ; n ++ ;
	XtSetArg ( xArg[n], XtNcallback , pOptionPreferenceClose_CallbackRec ) ; n ++ ;
	wDlgOptionPreferenceCmdClose = XtCreateManagedWidget ( "CmdButton", commandWidgetClass, wDlgOptionPreferenceForm, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNlabel    , "Cancel" ) ; n ++ ;
	XtSetArg ( xArg[n], XtNtop      , XtChainBottom ) ; n ++ ;
	XtSetArg ( xArg[n], XtNbottom   , XtChainBottom ) ; n ++ ;
	XtSetArg ( xArg[n], XtNleft     , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNright    , XtChainLeft   ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromVert , wDlgOptionPreferenceEdit ) ; n ++ ;
	XtSetArg ( xArg[n], XtNfromHoriz, wDlgOptionPreferenceCmdClose ) ; n ++ ;
	XtSetArg ( xArg[n], XtNcallback , pOptionPreferenceCancel_CallbackRec ) ; n ++ ;
	wDlgOptionPreferenceCmdCancel = XtCreateManagedWidget ( "CmdButton", commandWidgetClass, wDlgOptionPreferenceForm, xArg, n ) ;

}


/******************************************************************************/
/*  xmemo_DlgOptionPreference_SetFont                                         */
/******************************************************************************/

void xmemo_DlgOptionPreference_SetFont ( char *pFont )
{

int 	n ;
Arg 	xArg [ 5 ] ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNstring, pFont ) ; n ++ ;
	XtSetValues ( wDlgOptionPreferenceTxtFont, xArg, n ) ;

}

/******************************************************************************/
/*  xmemo_PopupDialog_MemoAttribute                                           */
/******************************************************************************/

int xmemo_PopupDialog_MemoAttribute ( zMemoType *pMemo )
{

int 	i, n ;
Arg 	xArg [ 10 ] ;
char	sBuf [ 20 ] ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "xmemo_PopupDialog_MemoAttribute", NULL ) ;

	n = 0 ;
	sprintf ( sBuf, "%d", pMemo->w ) ;
	XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
	XtSetValues ( wDlgOptionPreferenceTxtSizeW, xArg, n ) ;

	n = 0 ;
	sprintf ( sBuf, "%d", pMemo->h ) ;
	XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
	XtSetValues ( wDlgOptionPreferenceTxtSizeH, xArg, n ) ;

	n = 0 ;
	sprintf ( sBuf, "%d", pMemo->iBorderWidth ) ;
	XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
	XtSetValues ( wDlgOptionPreferenceTxtBorderW, xArg, n ) ;

	if ( pMemo->pFontName != NULL ) {
		n = 0 ;
		XtSetArg ( xArg[n], XtNstring, pMemo->pFontName ) ; n ++ ;
		XtSetValues ( wDlgOptionPreferenceTxtFont, xArg, n ) ;
	}

	for ( i = 0 ; i < 3 ; i ++ ) {

		n = 0 ;
		sprintf ( sBuf, "%d", pMemo->iBackColor[i] ) ;
		XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
		XtSetValues ( wDlgOptionPreferenceTxtBackColor[i], xArg, n ) ;

		n = 0 ;
		sprintf ( sBuf, "%d", pMemo->iBorderColor[i] ) ;
		XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
		XtSetValues ( wDlgOptionPreferenceTxtBorderColor[i], xArg, n ) ;

		n = 0 ;
		sprintf ( sBuf, "%d", pMemo->iFontColor[i] ) ;
		XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
		XtSetValues ( wDlgOptionPreferenceTxtFontColor[i], xArg, n ) ;

	}

	pMemoAttribute = pMemo ;

	XtPopup ( wDlgOptionPreference, XtGrabExclusive ) ;

	return RC_SUCCESS ;
	
}

/******************************************************************************/
/*  xmemo_PopupDialog_OptionPreference                                        */
/******************************************************************************/

int xmemo_PopupDialog_OptionPreference ( )
{

int 	i, n ;
Arg 	xArg [ 10 ] ;
char	sBuf [ 20 ] ;

	if ( bMemoTraceLog ) xmemo_TraceLog ( "xmemo_PopupDialog_OptionPreference", NULL ) ;

	n = 0 ;
	sprintf ( sBuf, "%d", iDefaultMemoWidth ) ;
	XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
	XtSetValues ( wDlgOptionPreferenceTxtSizeW, xArg, n ) ;

	n = 0 ;
	sprintf ( sBuf, "%d", iDefaultMemoHeight ) ;
	XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
	XtSetValues ( wDlgOptionPreferenceTxtSizeH, xArg, n ) ;

	n = 0 ;
	sprintf ( sBuf, "%d", iDefaultMemoBorderWidth ) ;
	XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
	XtSetValues ( wDlgOptionPreferenceTxtBorderW, xArg, n ) ;

	n = 0 ;
	XtSetArg ( xArg[n], XtNstring, sDefaultMemoFontName ) ; n ++ ;
	XtSetValues ( wDlgOptionPreferenceTxtFont, xArg, n ) ;

	for ( i = 0 ; i < 3 ; i ++ ) {

		n = 0 ;
		sprintf ( sBuf, "%d", iDefaultMemoBackColor[i] ) ;
		XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
		XtSetValues ( wDlgOptionPreferenceTxtBackColor[i], xArg, n ) ;

		n = 0 ;
		sprintf ( sBuf, "%d", iDefaultMemoBorderColor[i] ) ;
		XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
		XtSetValues ( wDlgOptionPreferenceTxtBorderColor[i], xArg, n ) ;

		n = 0 ;
		sprintf ( sBuf, "%d", iDefaultMemoFontColor[i] ) ;
		XtSetArg ( xArg[n], XtNstring, sBuf ) ; n ++ ;
		XtSetValues ( wDlgOptionPreferenceTxtFontColor[i], xArg, n ) ;

	}

	pMemoAttribute = NULL ;

	XtPopup ( wDlgOptionPreference, XtGrabExclusive ) ;

	return RC_SUCCESS ;
	
}

/******************************************************************************/
/*  xmemo_PopdownDialog_OptionPreference                                      */
/******************************************************************************/

int xmemo_PopdownDialog_OptionPreference ( )
{

	if ( bMemoTraceLog ) xmemo_TraceLog ( "xmemo_PopdownDialog_OptionPreference", NULL ) ;

	XtPopdown ( wDlgOptionPreference ) ;

	return RC_SUCCESS ;

}
