/******************************************************************************/
/*                                                                            */
/*  <<< Copyright >>>                                                         */
/*                                                                            */
/*  The "xmemo" software is copyright 1999 by Takao Abe.                      */
/*  All rights reserved.                                                      */
/*                                                                            */
/*  The "xmemo" software refers to the source code, the binary code,          */
/*  the documents, and all derivatives based on this software under           */
/*  the copyright law, that is a software containing a program or a           */
/*  portion of a program, regardless of modifications and/or translations.    */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  <<< Licence and redistribution >>>                                        */
/*                                                                            */
/*  The source code and the binary code are free software.                    */
/*  The use and redistribution of source code and binary code are permitted   */
/*  provided that the following conditions are met:                           */
/*  You may use the software for private use and commercial use,              */
/*  and may modify your copy or copies of the software or any portion of it.  */
/*                                                                            */
/*  THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESSED OR IMPLIED            */
/*  WARRANTIES OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED        */
/*  WARRANTIES OF MERCHANTABLILITY AND FITNESS FOR A PARTICULAR PURPOSE.      */
/*  IN NO EVENT SHALL THE AUTHOR TAKAO ABE BE LIABLE FOR ANY DIRECT,          */
/*  INDIRECT, GENERAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES           */
/*  ( INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR       */
/*  SERVICES; LOSS OF USE, DATA OR PROFITS; OR BUSINESS INTERRUPTION )        */
/*  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,       */
/*  STRICT LIABILITY, OR TORT ( INCLUDING NEGLIGENCE OR OTHERWISE )           */
/*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED       */
/*  OF THE POSSIBILITY OF SUCH DAMAGE.                                        */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with or without     */
/*  modification, the whole program or a portion of it, are permitted         */
/*  provided that one retains the entire copyright notice properly, and       */
/*  displays or retains this license in the documentation and/or other        */
/*  materials provided with the distribution.                                 */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with modification,  */
/*  the whole program or a portion of it, are permitted provided that one     */
/*  declares that it is modified software and not original, and displays or   */
/*  describes any modifications in the documentation and/or other materials   */
/*  provided with the distribution.                                           */
/*                                                                            */
/*  This software and the name of the author must not be used to endorse or   */
/*  promote products derived from this software without prior written         */
/*  permission.                                                               */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  EMail   abetakao@bea.hi-ho.ne.jp                                          */
/*          HCA00763@nifty.ne.jp                                              */
/*                                                                            */
/*  URL     http://www.bea.hi-ho.ne.jp/abetakao/                              */
/*                                                                            */
/******************************************************************************/


#ifndef _INCLUDE_XMEMO_H
#define _INCLUDE_XMEMO_H



#ifndef		TRUE
#define		TRUE	(1==1)
#endif
#ifndef		FALSE
#define		FALSE	(!TRUE)
#endif

#define		CHARSET_ASCII	'A'
#define		CHARSET_EUC 	'E'
#define		CHARSET_JIS7	'7'
#define		CHARSET_JIS8	'8'
#define		CHARSET_SJIS	'S'

#define		MAXLEN_FILENAME 	128

#define		MAXLEN_PASSWORD 	32
#define		MAXLEN_GROUPNAME	64
#define		MAXLEN_NICKNAME 	64
#define		MAXLEN_USERNAME 	64
#define		MAXLEN_HOSTNAME 	254
#define		MAXLEN_FONTNAME 	128
#define		MAXLEN_MESSAGE  	8000
#define		MAXLEN_PACKET    	(1000+MAXLEN_MESSAGE+MAXLEN_GROUPNAME+MAXLEN_NICKNAME+MAXLEN_USERNAME+MAXLEN_HOSTNAME+MAXLEN_FONTNAME)

#define		XMEMO_TRANSACTION_DELETE	'D'
#define		XMEMO_TRANSACTION_INSERT	'I'
#define		XMEMO_TRANSACTION_UPDATE	'U'

#define		XMEMO_ICON_POSITION_SEPERATE    		0
#define		XMEMO_ICON_POSITION_LEFT_TOP    		11
#define		XMEMO_ICON_POSITION_LEFT_CENTER 		12
#define		XMEMO_ICON_POSITION_LEFT_BOTTOM 		13
#define		XMEMO_ICON_POSITION_CENTER_TOP   		21
#define		XMEMO_ICON_POSITION_CENTER_CENTER		22
#define		XMEMO_ICON_POSITION_CENTER_BOTTOM		23
#define		XMEMO_ICON_POSITION_RIGHT_TOP   		31
#define		XMEMO_ICON_POSITION_RIGHT_CENTER		32
#define		XMEMO_ICON_POSITION_RIGHT_BOTTOM		33

#define		XMEMO_STATE_ANY_IDLE    		0
#define		XMEMO_STATE_ANY_CONNECTING		1
#define		XMEMO_STATE_ANY_CONNECTED		2
#define		XMEMO_STATE_ANY_SENT    		3
#define		XMEMO_STATE_ANY_STOP    		9

#define		XMEMO_SOCKET_UDP        	'U'
#define		XMEMO_SOCKET_TCP_LISTEN 	'L'
#define		XMEMO_SOCKET_TCP_ACCEPT 	'A'
#define		XMEMO_SOCKET_TCP_CONNECT	'C'

#define		XMEMO_PROTOCOL_INVALID	' '
#define		XMEMO_PROTOCOL_IPMSG  	'I'
#define		XMEMO_PROTOCOL_OBOEGAKI	'O'
#define		XMEMO_PROTOCOL_HUSEN  	'H'

#define		XMEMO_CYPHER_NONE		' '
#define		XMEMO_CYPHER_PGP 		' '

#define		XMEMO_SEARCH_INVALID  	' '
#define		XMEMO_SEARCH_BROADCAST	'B'
#define		XMEMO_SEARCH_HOST     	'H'
#define		XMEMO_SEARCH_RANGE    	'R'

#define		MIN_DEFAULT_MEMO_WIDTH  	10
#define		MAX_DEFAULT_MEMO_WIDTH  	500
#define		MIN_DEFAULT_MEMO_HEIGHT 	10
#define		MAX_DEFAULT_MEMO_HEIGHT 	500
#define		MIN_DEFAULT_BORDER_WIDTH	0
#define		MAX_DEFAULT_BORDER_WIDTH	100



typedef struct zChainStruct {
	struct zChainStruct	*pNext ;
	struct zChainStruct	*pBack ;
	void               	*pData ;
} zChainType ;


typedef struct zAnchorStruct {
	struct zChainStruct	*pHead ;
	struct zChainStruct	*pTail ;
} zAnchorType ;


typedef struct zSocketStruct {
	struct	zChainStruct	*pChain ;
	char	cSockType ; 	/* XMEMO_SOCKET_XXXXX */
	char	cProtocol ;
	int 	iSock ;
	unsigned	long	iAddr ;
	unsigned	short	iPort ;
	time_t	tTimeout ;
	XtInputId	iCallbackReadId ;
	XtInputId	iCallbackWriteId ;
	XtInputId	iCallbackExceptId ;
} zSocketType ;


typedef struct zMemoStruct {
	struct	zChainStruct	*pChain ;
	Widget		wMemo, wForm, wText, wBorderBottom, wBorderRight, wBorderCorner ;
	int 		iMouseRootX, iMouseRootY ;
	char		bMousePress ;
	char		bMouseDrag ;
	char		cTransaction ;			/* XMEMO_TRANSACTION_XXXXXX */
	int 		x, y, w, h, iBorderWidth ;
	int 		iIconX, iIconY, iIconW, iIconH, iIconBorderWidth ;
	char		bIcon ;
	char		cIconPosition ;			/* XMEMO_ICON_POSITION_XXXXXX */
	char		iIconType ;
	long		iBorderColor [ 3 ] ;	/* RGB */
	long		iBackColor [ 3 ] ;		/* RGB */
	long		iFontColor [ 3 ] ;		/* RGB */
	char		*pFontName ;
	XFontStruct	*pFontStruct ;
	int 		iFontSize ;				/* Not used */
	time_t		tCreate ;
	int 		iSerial ;
	time_t		tExpire ;
	char		*pText ;
	char		cProtocol ; /* Received memo through the network */
	unsigned	long	iAddr ;     /* Received memo through the network */
	unsigned	short	iPort ;     /* Received memo through the network */
	int 		iRecvNo ;	/* Received memo through the network */
	char		*pHost ;    /* Received memo through the network */
	char		*pUser ;    /* Received memo through the network */
	char		*pNick ;    /* Received memo through the network */
	char		*pGroup ;   /* Received memo through the network */
	int 		iSendCount ;
} zMemoType ;


typedef struct zMemberStruct {
	struct	zChainStruct	*pChain ;
	char		cProtocol ;		/* Network  Send/Receive */
	unsigned	long	iAddr ; 		/* Network  Send/Receive */
	unsigned	short	iPort ; 		/* Network  Send/Receive */
	char		cCypher ;		/* Not used              */
	int 		iSendNo ;		/* Network  Send         */
	short		iState ;		/* Network  Send         */
	short		iRetry ;		/* Network  Send         */
	time_t		tTimeout ;		/* Network  Send         */
	struct	zMemoStruct  	*pSendMemo ;	/* Network  Send         */
	struct	zSocketStruct	*pUdpSocket ;	/* Network  Send         */
	struct	zSocketStruct	*pTcpSocket ;	/* Network  Send         */
	char		*pHost ; 		/* Network  Receive      */
	char		*pUser ; 		/* Network  Receive      */
	char		*pNick ; 		/* Network  Receive      */
	char		*pGroup ;		/* Network  Receive      */
	char		bAbsence ;		/* Network  Receive      */
	char		bDelete ;		/* Network  Delete flag  */
	char		*pLine ;		/* Dialog   List entry   */
	char		bSelect ;		/* Dialog   Select flag  */
} zMemberType ;


typedef struct zNetworkStruct {
	struct	zChainStruct	*pChain ;
	char		cProtocol ;		/* Option   XMEMO_PROTOCOL_XXXXX */
	char		cSearch ;		/* Option   XMEMO_SEARCH_XXXXX   */
	char		*pAddr [ 2 ] ;	/* Option               */
	char		*pPort ;		/* Option               */
	char		bEnable ;		/* Option   TRUE,FALSE  */
	unsigned	long	iAddr [ 2 ] ;	/* Network              */
	unsigned	short	iPort ; 		/* Network              */
	char		bActive ;		/* Network  TRUE,FALSE  */
	char		bDelete ;		/* Dialog   Delete flag */
	char		bInsert ;		/* Dialog   Insert flag */
	char		*pLine ;		/* Dialog   List entry  */
	struct	zSocketStruct	*pUdpSock ;
	struct	zSocketStruct	*pTcpSock ;
} zNetworkType ;	



#endif

