/******************************************************************************/
/*                                                                            */
/*  <<< Copyright >>>                                                         */
/*                                                                            */
/*  The "xmemo" software is copyright 1999 by Takao Abe.                      */
/*  All rights reserved.                                                      */
/*                                                                            */
/*  The "xmemo" software refers to the source code, the binary code,          */
/*  the documents, and all derivatives based on this software under           */
/*  the copyright law, that is a software containing a program or a           */
/*  portion of a program, regardless of modifications and/or translations.    */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  <<< Licence and redistribution >>>                                        */
/*                                                                            */
/*  The source code and the binary code are free software.                    */
/*  The use and redistribution of source code and binary code are permitted   */
/*  provided that the following conditions are met:                           */
/*  You may use the software for private use and commercial use,              */
/*  and may modify your copy or copies of the software or any portion of it.  */
/*                                                                            */
/*  THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESSED OR IMPLIED            */
/*  WARRANTIES OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED        */
/*  WARRANTIES OF MERCHANTABLILITY AND FITNESS FOR A PARTICULAR PURPOSE.      */
/*  IN NO EVENT SHALL THE AUTHOR TAKAO ABE BE LIABLE FOR ANY DIRECT,          */
/*  INDIRECT, GENERAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES           */
/*  ( INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR       */
/*  SERVICES; LOSS OF USE, DATA OR PROFITS; OR BUSINESS INTERRUPTION )        */
/*  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,       */
/*  STRICT LIABILITY, OR TORT ( INCLUDING NEGLIGENCE OR OTHERWISE )           */
/*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED       */
/*  OF THE POSSIBILITY OF SUCH DAMAGE.                                        */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with or without     */
/*  modification, the whole program or a portion of it, are permitted         */
/*  provided that one retains the entire copyright notice properly, and       */
/*  displays or retains this license in the documentation and/or other        */
/*  materials provided with the distribution.                                 */
/*                                                                            */
/*  Redistribution and use in source form or binary form, with modification,  */
/*  the whole program or a portion of it, are permitted provided that one     */
/*  declares that it is modified software and not original, and displays or   */
/*  describes any modifications in the documentation and/or other materials   */
/*  provided with the distribution.                                           */
/*                                                                            */
/*  This software and the name of the author must not be used to endorse or   */
/*  promote products derived from this software without prior written         */
/*  permission.                                                               */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  EMail   abetakao@bea.hi-ho.ne.jp                                          */
/*          HCA00763@nifty.ne.jp                                              */
/*                                                                            */
/*  URL     http://www.bea.hi-ho.ne.jp/abetakao/                              */
/*                                                                            */
/******************************************************************************/


#ifndef _INCLUDE_XMEMODATA_H
#define _INCLUDE_XMEMODATA_H



#ifndef	XMEMODATA_C
#define	XMEMO_EXTERN	extern
#else
#define	XMEMO_EXTERN
#endif



/* General */

XMEMO_EXTERN	char	*pVersion ;
XMEMO_EXTERN	char	*pCopyright ;




/* System */

XMEMO_EXTERN	char	cMemoCharset ;

XMEMO_EXTERN	int 	iScreenWidth ;
XMEMO_EXTERN	int 	iScreenHeight ;



/* Directory and file names */

XMEMO_EXTERN	char	sMemoHomeDir [ MAXLEN_FILENAME ] ;
XMEMO_EXTERN	char	sMemoBaseDir [ MAXLEN_FILENAME ] ;
XMEMO_EXTERN	char	sMemoConfDir [ MAXLEN_FILENAME ] ;
XMEMO_EXTERN	char	sMemoDataDir [ MAXLEN_FILENAME ] ;
XMEMO_EXTERN	char	sMemoLogDir  [ MAXLEN_FILENAME ] ;

XMEMO_EXTERN	char	sFilenameMemoArchives     [ MAXLEN_FILENAME ] ;
XMEMO_EXTERN	char	sFilenameMemoTransactions [ MAXLEN_FILENAME ] ;

XMEMO_EXTERN	char	sFilenameOptionProfile    [ MAXLEN_FILENAME ] ;
XMEMO_EXTERN	char	sFilenameOptionPreference [ MAXLEN_FILENAME ] ;
XMEMO_EXTERN	char	sFilenameOptionLog        [ MAXLEN_FILENAME ] ;
XMEMO_EXTERN	char	sFilenameOptionNetwork    [ MAXLEN_FILENAME ] ;
XMEMO_EXTERN	char	sFilenameOptionSystem     [ MAXLEN_FILENAME ] ;

XMEMO_EXTERN	char	sFilenameErrorLog [ MAXLEN_FILENAME ] ;
XMEMO_EXTERN	char	sFilenameTraceLog [ MAXLEN_FILENAME ] ;



/* User's preferenece */

XMEMO_EXTERN	int 	iDefaultMemoWidth ;
XMEMO_EXTERN	int 	iDefaultMemoHeight ;
XMEMO_EXTERN	int 	iDefaultMemoBackColor [ 3 ] ;	/* RGB */
XMEMO_EXTERN	int 	iDefaultMemoBorderWidth ;
XMEMO_EXTERN	int 	iDefaultMemoBorderColor [ 3 ] ;	/* RGB */
XMEMO_EXTERN	char	sDefaultMemoFontName [ MAXLEN_FONTNAME ] ;
XMEMO_EXTERN	int 	iDefaultMemoFontColor [ 3 ] ;	/* RGB */
XMEMO_EXTERN	char	cDefaultMemoIconPosition ;
XMEMO_EXTERN	int 	iDefaultMemoIconType ;


XMEMO_EXTERN	int 	iDefaultSendDialogWidth ;
XMEMO_EXTERN	int 	iDefaultSendDialogHeight ;



/* User information */

XMEMO_EXTERN	char	sMemoPassword [ MAXLEN_PASSWORD ] ;
XMEMO_EXTERN	char	sMemoUsername [ MAXLEN_USERNAME ] ;
XMEMO_EXTERN	char	sMemoNickname [ MAXLEN_NICKNAME ] ;
XMEMO_EXTERN	char	sMemoGroupname [ MAXLEN_GROUPNAME ] ;



/* Host information */

XMEMO_EXTERN	char	sMemoHostname [ MAXLEN_HOSTNAME ] ;
XMEMO_EXTERN	char	sMemoHostaddr [ 16 ] ;
XMEMO_EXTERN	long	iMemoHostaddr ;



/* Log */

XMEMO_EXTERN	int 	bMemoLogSend ;
XMEMO_EXTERN	int 	bMemoLogReceive ;
XMEMO_EXTERN	int 	bMemoLogDelete ;
XMEMO_EXTERN	int 	iMemoLogKeep ;



/* Data */

XMEMO_EXTERN	char	iMemoCurrentDataFileFormatVersion ;
XMEMO_EXTERN	int 	bMemoTraceLog ;
XMEMO_EXTERN	int 	bMemoTracePacket ;



XMEMO_EXTERN	char	bUserAbsence ;		/* TRUE:Absence / FALSE:Presence */



XMEMO_EXTERN	zAnchorType	zMemoAnchor ;

XMEMO_EXTERN	zAnchorType	zMemberAnchor ;

XMEMO_EXTERN	zAnchorType	zNetworkAnchor ;

XMEMO_EXTERN	zAnchorType	zSocketAnchor ;

XMEMO_EXTERN	zMemoType	*pMemoActive ;

XMEMO_EXTERN	zAnchorType	zSendMemoAnchor ;
XMEMO_EXTERN	zAnchorType	zSendPeerAnchor ;


/* Main widget */

XMEMO_EXTERN	XtAppContext	xApp ;
XMEMO_EXTERN	Widget      	wTop ;
XMEMO_EXTERN	Widget      	wTopForm ;
XMEMO_EXTERN	Widget      	wTopMenu ;
XMEMO_EXTERN	Widget      	wTopStatusView ;
XMEMO_EXTERN	Widget      	wTopStatusList ;



#endif
